// ==============================================================
//                 ORBITER MODULE: CENTURI1
//                  Part of the ORBITER SDK
//          Copyright (C) 2002-2004 Martin Schweiger
//                   All rights reserved
//
// CENTURI1.cpp
// Control module for CENTURI1 vessel class
//

// ==============================================================
#define ORBITER_MODULE
#include "orbitersdk.h"
#include "CENTURI1.h"
#include "OrbiterSoundSDK35.h"
#include "ColorNames.h"
VISHANDLE MainExternalMeshVisual = 0;


void CENTURI1::clbkPostCreation (void)

{
JohnSoundID=ConnectToOrbiterSoundDLL3(GetHandle());
SoundOptionOnOff3(JohnSoundID,PLAYMAINTHRUST,FALSE);

SoundOptionOnOff3(JohnSoundID,PLAYHOVERTHRUST,FALSE);
SoundOptionOnOff3(JohnSoundID,PLAYATTITUDETHRUST,FALSE);

SoundOptionOnOff3(JohnSoundID,PLAYCOUNTDOWNWHENTAKEOFF,FALSE);

SoundOptionOnOff3(JohnSoundID,PLAYCABINAIRCONDITIONING,FALSE);

SoundOptionOnOff3(JohnSoundID,PLAYCABINRANDOMAMBIANCE,FALSE);

SoundOptionOnOff3(JohnSoundID,PLAYRADIOATC,FALSE);

SoundOptionOnOff3(JohnSoundID,DISPLAYTIMER,FALSE);
}// Constructor
CENTURI1::CENTURI1 (OBJHANDLE hObj, int fmodel)
: VESSEL2 (hObj, fmodel)



{

    LP1_pos.x =    0;
    LP1_pos.y = 52.68;
    LP1_pos.z = -111;
 
LP5_pos.x =  44;
    LP5_pos.y = -34.93;
    LP5_pos.z =44;
   //        171.9947 9.04763  473.7592
LP3_pos.x =   0;
    LP3_pos.y = 52.68;
    LP3_pos.z =111;  
   //-410.2275 12.40105 -385.2259
LP4_pos.x =   169;
    LP4_pos.y =52.488;
    LP4_pos.z = 0;
     //   -404.3922 12.749  257.6972
LP2_pos.x =     -169;
    LP2_pos.y = 52.488;
    LP2_pos.z = 0;       
DOCK1_status = RDOOR_UP;
DOCK2_status = RDOOR_UP;
DOCK3_status = RDOOR_UP;
DOCK4_status = RDOOR_UP;
DOCK1_proc = 0;
DOCK2_proc = 0;
DOCK3_proc = 0;
DOCK4_proc = 0;
LIFT_SPEED =.1;
L_SPEED =.1;
CAM = 0;
MAX_GRAP_DIST=100;
	DefineAnimations ();
APSel= 0;	
PADSel=1;	
LP1_INT_POS=-111;
LP2_INT_POS=-169;
LP3_INT_POS=111;
LP4_INT_POS=169;	
}
void CENTURI1::SelectCockpitView (int CAM)
{

     switch (CAM) {
  case 0:  //pad
          SetCameraDefaultDirection (_V(.7,0,.7));
          SetCameraOffset (_V(35.83,-34.095,35.83));
		  oapiCameraSetCockpitDir (0,0);
          break;
      case 1:  //tube1
          SetCameraDefaultDirection (_V(0,0,-1));
          SetCameraOffset (_V(0,65,-105));
		  oapiCameraSetCockpitDir (0,0);
          break;
          case 2:  //tube2
          SetCameraDefaultDirection (_V(-1,0,0));
          SetCameraOffset (_V(-150,65,0));
		  oapiCameraSetCockpitDir (0,0);
          break;
      case 3:  //tube3
          SetCameraDefaultDirection (_V(0,0,1));
          SetCameraOffset (_V(0,65,105));
		  oapiCameraSetCockpitDir (0,0);
          break;
          case 4:  //tube4
          SetCameraDefaultDirection (_V(1,0,0));
          SetCameraOffset (_V(150,65,0));
		  oapiCameraSetCockpitDir (0,0);
          break;
	 }}
////////////////////////////////////////////////////////
// SendHudMessage
////////////////////////////////////////////////////////
char *CENTURI1::SendHudMessage()
{
dHudMessageDelay=15;
return cUmmuHudDisplay;
}
void CENTURI1::clbkSetClassCaps (FILEHANDLE cfg)
{
// physical specs
	SetSize (295);
	SetEmptyMass (10000.0);
	SetCW (0.3, 0.3, 0.6, 0.9);
	SetWingAspect (0.1);
	SetWingEffectiveness (0.1);
	SetCrossSections (_V(12988.42,11516.08,15632.45));
	SetRotDrag (_V(0.1,0.1,0.1));
	if (GetFlightModel() >= 1) {
		SetPitchMomentScale (1e-4);
		SetBankMomentScale (1e-4);
	}
	SetPMI (_V(6265.72,5387.235,7960.94));
	SetTrimScale (0.05);
	SetCameraOffset (_V(37.448,-34.095,37.488));
	
	SetTouchdownPoints  (_V(0,-2.158,1), _V(-1.6,-2.158,-1), _V(1.6,-2.158,-1));; 
//D1 = CreateAttachment (false, _V(0,53.798,-140),_V(0,0,1),_V(1,0,0),"1",false);
//D2 = CreateAttachment (false, _V(-205,53.798,0),_V(1,0,0),_V(0,0,1),"2",false);
//D3 = CreateAttachment (false, _V(0,53.798,140),_V(0,0,1),_V(1,0,0),"3",false);
//D4 = CreateAttachment (false, _V(205,53.798,0),_V(1,0,0),_V(0,0,1),"4",false);
D5 = CreateAttachment (false, _V(44,-34.93,44),_V(0,1,0),_V(-.7,0,.7),"PAD",false);
 

static VECTOR3 APbeaconcol[5] = {{1,1,1},
                                    {1,1,1},
                                  {1,1,1},
                                    {1,1,1},
                                   {1,1,1}
								   
                                   
                                   
                                  };

    for ( i = 0; i < 6; i++) {
        APbeacon[i].shape = BEACONSHAPE_STAR;
        APbeacon[i].pos = APbeaconpos+i;
        APbeacon[i].col = APbeaconcol+i;
        APbeacon[i].size = 3;
        APbeacon[i].falloff =  0.4;
        APbeacon[i].period = 0.8;
        APbeacon[i].duration = 0.3;
        APbeacon[i].tofs = (6-i)*0.2;
        APbeacon[i].active = false;
        AddBeacon (APbeacon+i);
    }

        APbeacon[0].active = true;


 


EnableTransponder (true);

    PROPELLANT_HANDLE TANK;
    TANK = CreatePropellantResource (PB_FUELMASS);

	// ***************** thruster definitions *******************
	

PROPELLANT_HANDLE hpr = CreatePropellantResource (PB_FUELMASS);
	// ***************** thruster definitions *******************
THRUSTER_HANDLE th_main, th_retro,th_att_rot[4], th_att_lin[4];		
	th_main = CreateThruster (_V(0,0,0), _V(0,0,1), PB_MAXMAINTH, hpr, PB_ISP);
	CreateThrusterGroup (&th_main, 1, THGROUP_MAIN);
	
	th_retro = CreateThruster (_V(0,0,0), _V(0,0,-1), PB_MAXMAINTH, hpr, PB_ISP);
	CreateThrusterGroup (&th_retro, 1, THGROUP_RETRO);
	
	



	th_att_rot[0] = CreateThruster (_V(0.0, 0, 22.759), _V(0,-1,0), PB_MAXRCSTH, hpr, PB_ISP);
	th_att_rot[1] = CreateThruster (_V(0.0, 0, -22.759), _V(0,1,0), PB_MAXRCSTH, hpr, PB_ISP);
	th_att_rot[2] = CreateThruster (_V(0.0, 0, 22.759), _V(0,1,0), PB_MAXRCSTH, hpr, PB_ISP);
	th_att_rot[3] = CreateThruster (_V(0.0, 0, -22.759), _V(0,-1,0), PB_MAXRCSTH, hpr, PB_ISP);
	CreateThrusterGroup (th_att_rot,   2, THGROUP_ATT_PITCHDOWN);
	CreateThrusterGroup (th_att_rot+2,   2, THGROUP_ATT_PITCHUP);
	
	th_att_rot[0] = CreateThruster (_V( 22.759,0,0), _V(0,-1,0), PB_MAXRCSTH, hpr, PB_ISP);
	th_att_rot[1] = CreateThruster (_V(-22.759,0,0), _V(0,1,0), PB_MAXRCSTH, hpr, PB_ISP);
	th_att_rot[2] = CreateThruster (_V(22.759,0,0), _V(0,1,0), PB_MAXRCSTH, hpr, PB_ISP);
	th_att_rot[3] = CreateThruster (_V(-22.759,0,0), _V(0,-1,0), PB_MAXRCSTH, hpr, PB_ISP);
	CreateThrusterGroup (th_att_rot, 2, THGROUP_ATT_BANKRIGHT);
	CreateThrusterGroup (th_att_rot+2, 2, THGROUP_ATT_BANKLEFT);
	
	

	th_att_rot[0] = CreateThruster (_V( 14.6,0,0), _V(0,0,-1), PB_MAXRCSTH, hpr, PB_ISP);
	th_att_rot[1] = CreateThruster (_V(-14.6,0,0), _V(0,0,1), PB_MAXRCSTH, hpr, PB_ISP);
	th_att_rot[2] = CreateThruster (_V( 14.6,0,0), _V(0,0,1), PB_MAXRCSTH, hpr, PB_ISP);
	th_att_rot[3] = CreateThruster (_V(-14.6,0,0), _V(0,0,-1), PB_MAXRCSTH, hpr, PB_ISP);
	CreateThrusterGroup (th_att_rot, 2, THGROUP_ATT_YAWRIGHT);
	CreateThrusterGroup (th_att_rot+2, 2, THGROUP_ATT_YAWLEFT);




	
	th_att_lin[0] = CreateThruster (_V( 22.759,0,0), _V(0,1,0), PB_MAXRCSTH, hpr, PB_ISP);
	th_att_lin[1] = CreateThruster (_V(-22.759,0,0), _V(0,1,0), PB_MAXRCSTH, hpr, PB_ISP);
	th_att_lin[2] = CreateThruster (_V(22.759,0,0), _V(0,-1,0), PB_MAXRCSTH, hpr, PB_ISP);
	th_att_lin[3] = CreateThruster (_V(-22.759,0,0), _V(0,-1,0), PB_MAXRCSTH, hpr, PB_ISP);	
	CreateThrusterGroup (th_att_lin,   2, THGROUP_ATT_UP);
	CreateThrusterGroup (th_att_lin+2, 2, THGROUP_ATT_DOWN);



	th_att_lin[0] = CreateThruster (_V( 22.759,0,0), _V(0,0,1), PB_MAXRCSTH, hpr, PB_ISP);
	th_att_lin[1] = CreateThruster (_V(-22.759,0,0), _V(0,0,1), PB_MAXRCSTH, hpr, PB_ISP);
	th_att_lin[2] = CreateThruster (_V(22.759,0,0), _V(0,0,-1), PB_MAXRCSTH, hpr, PB_ISP);
	th_att_lin[3] = CreateThruster (_V(-22.759,0,0), _V(0,0,-1), PB_MAXRCSTH, hpr, PB_ISP);	
	CreateThrusterGroup (th_att_lin,   2, THGROUP_ATT_FORWARD);
	CreateThrusterGroup (th_att_lin+2, 2, THGROUP_ATT_BACK);


	th_att_lin[0] = CreateThruster (_V(0,0,22.759), _V(1,0,-0.3), PB_MAXRCSTH, hpr, PB_ISP);
	th_att_lin[1] = CreateThruster (_V(0,0,-22.759), _V(1,0,-0.3), PB_MAXRCSTH, hpr, PB_ISP);
	th_att_lin[2] = CreateThruster (_V(0,0,22.759), _V(-1,0,0.3), PB_MAXRCSTH, hpr, PB_ISP);
	th_att_lin[3] = CreateThruster (_V(0,0,-22.759), _V(-1,0,0.3), PB_MAXRCSTH, hpr, PB_ISP);	
	CreateThrusterGroup (th_att_lin,   2, THGROUP_ATT_RIGHT);
	CreateThrusterGroup (th_att_lin+2, 2, THGROUP_ATT_LEFT);
	
	SelectedUmmuMember=0;
	clbkSetClassCaps_UMMu();	
	
// visual specs
// visual specs
SetMeshVisibilityMode (AddMesh (oapiLoadMeshGlobal ("CENTURI2")), MESHVIS_ALWAYS); //Main ship mesh





}
// =======================================================
// UMMU Class Caps
// =======================================================
void CENTURI1::clbkSetClassCaps_UMMu(void)
{
//--------------------------------------------------------------
	// InitUmmu
	// initialisation of Ummu must be done first ! return of 1 mean OK 
	// return of -999 mean Ummu addon is not installed in user's Orbiter, return of -1 
	// mean misc error. If error simply all function will fail silently 
	// and there will be no MMu. It's a good idea to warn the user. 
	// (see function "WarnUserUMMUNotInstalled" below)
	Crew.InitUmmu(GetHandle());	
	//--------------------------------------------------------------

	//--------------------------------------------------------------
	// GetUserUMmuVersion
	// this check wich version of UMmu addon the user have in his orbiter directory.
	// this may be usefull for future version with more function so you can check
	// if user installation support the new functions. Return -1 on error (not installed, version cannot be read)
	// or version number in float value (ie: 2.0="2.0" version etc etc)
	float UMmuVersion=Crew.GetUserUMmuVersion();

	//--------------------------------------------------------------
	// DefineAirLockShape
	// We set the airlock shape and state, this virtual box will be the one
	// into were a Ummu asking to reenter will be taken in account
	// first parameter is airlock door state (OPEN=TRUE) and other are X,X1,Y,Y1 and Z,Z1 
	// min and max coordinate for this virtual box (vessel local coordinate)
	// Pay attention to reenter when landed (if suitable) and make the box large enough so 
	// it's not a pain for the user to find airlock's entry. (See PDF doc)
Crew.DefineAirLockShape(TRUE,22,66,-40,-18,22,66); 
		// Airlock open, 2 meter large 4 meter high 6 meter long (vessel local coordinate)

	//--------------------------------------------------------------
	// SetMembersPositionOrientationOnEVA
	// We define here were the Ummu will appear when they make an EVA
	// first parameter is position second is orientation, take care not to make
	// them appear to high on ground (will fall and die) or to low (Orbiter "light speed" bug)
	Crew.SetMembersPosRotOnEVA(_V(40,-36,40),_V(0,0,0));	// 3 meters in front of ship (z) facing direction of ship (vessel local coordinate)

	//---------------------------------------------------------------
	// finally set the maximum seat available in this ship, default is
	// 8 but it can go from 1 to 100
	// BAD IDEA: using this to "close" your ship, use "SetAirlockDoorState" instead.
	Crew.SetMaxSeatAvailableInShip(99);

	//------------------------------------------------------------------
	// IMPORTANT
	// at this point Ummu is ready to be used (appart save/load see below "clbkSaveState" "clbkLoadStateEx")
	// we'll add below some >default< crew member for when the ship is spawned by Orbiter's 
	// scenerio editor. (As there is no "scn" scenario loading in this case, your ship would have no crew)
	// pay attention that if a scenario is loaded the members added here will be deleted first. 
	// You can also add new members at any time during runtime.
	// IDEA: Make here a selection of random name, crew, number age, etc etc. Up to you,
	// each scenario created dynamically would have then a different crew.
	//------------------------------------------------------------------

	Crew.AddCrewMember("Paul Roper",41,65,74,"99M");	//(for name and id a-z A-Z 0-9 characters only)
	Crew.AddCrewMember("Frank Craig",27,67,55,"99");	//(for name and id a-z A-Z 0-9 characters only)
	Crew.AddCrewMember("Craig Collins",25,70,45,"99P");	//(for name and id a-z A-Z 0-9 characters only)
	Crew.AddCrewMember("Doug Jackson",45,70,45,"99D" );	//(for name and id a-z A-Z 0-9 characters only)
	Crew.AddCrewMember("Keith Ford",45,70,45,"99T");	//(for name and id a-z A-Z 0-9 characters only)
	Crew.AddCrewMember("Paul Foster",45,70,45,"99R" );	//(for name and id a-z A-Z 0-9 characters only)
	cUmmuHudDisplay[0] =0;	// Initialisation of UMmu hud char variable
	dHudMessageDelay =0;	// Initialisation of UMmu delay variable
	strcpy(SendHudMessage(),"Welcome aboard ! E=EVA 1,2=select UMmu D=Open/Close airlock S=info M=add crew");

	// The Add mmu without scenery editor variable see PDF doc
	cAddUMmuToVessel[0]=0;
}




void CENTURI1::clbkPostStep(double simt, double simdt, double mjd)

{
//---------------------------------------------------------------------------
	// ProcessUniversalMMu
	// Here the routine that detect if someone entered the ship (eva or transfer)
	// No need to manage anything here all is automatic, crew is added to your ship, ship's weight is updated,
	// and UMmu vessel is automatically deleted from Orbiter. You may just look the return
	// code to see if someone entered and display wathewer message on panel or other.
	// notice it's FPS friendly, function process only 4 time per second not each frame 
	// and return immediately if airlock closed or no Ummu is detected in vincinity. 
	int ReturnCode=Crew.ProcessUniversalMMu();
	switch(ReturnCode)
	{
	case UMMU_TRANSFERED_TO_OUR_SHIP: 
		sprintf(SendHudMessage(),"%s \"%s\" aged %i was transfered to our ship",
		Crew.GetCrewMiscIdByName(Crew.GetLastEnteredCrewName()),Crew.GetLastEnteredCrewName()
		,Crew.GetCrewAgeByName(Crew.GetLastEnteredCrewName()));
		break;
	case UMMU_RETURNED_TO_OUR_SHIP:
		sprintf(SendHudMessage(),"%s \"%s\" aged %i entered into our ship",
		Crew.GetCrewMiscIdByName(Crew.GetLastEnteredCrewName()),
		Crew.GetLastEnteredCrewName(),Crew.GetCrewAgeByName(Crew.GetLastEnteredCrewName()));
		break;
	}
	if(GroundContact()==TRUE)
	{
		// we check vertical speed
		//int I;
		VECTOR3 vHorizonAirspeedVector={0};
		GetHorizonAirspeedVector (vHorizonAirspeedVector);
		double VertSpeed		=vHorizonAirspeedVector.y;
		if(VertSpeed<-3)
		{
			// we touched ground with more than -3 m/s, sorry dude, time to kill you all :(
			//for(I=0;I<Crew.GetCrewTotalNumber();I++)
			//{
		//		Crew.SetCrewMemberPulseBySlotNumber(I,0);	// set cardiac pulse to zero
		//	}
		//	strcpy(SendHudMessage(),"Oooh no ! Crash - All crew aboard killed");
		}

		// TIPS: the vertical speed is often reset to zero when there is ground contact
		// this may bug somewhat the death of your crew.
		// to have an accurate VertSpeed at touchdown I recommand to record it at very END 
		// of timestep and use this "old" value. The next frame you'll have the vertspeed value 
		// of *last frame* just before the crash (GroundContact). This ensure an accurate 
		// verticalspeed value. (keep this value in your vessel class and don't forget to 
		// initialize it at zero in setclasscap)
	}

//sprintf(oapiDebugString(),"anim %2.2f", AIRLOCK_proc);

	//---------------------------------------------------------------------------
	// WarnUserUMMUNotInstalled - IMPORTANT helper
	// Put here this function and users will be automatically warned if they don't have
	// UMMU installed or if it's outdated. Warning text duration is 20 seconds and text is:
	// [AddonName] require "Universal MMU" ver 2.0 or higher. Download at www.orbiter.dansteph.com (message countdown in seconds)
	// an additonal "your version of UMMU is outdated" is displayed the last 5 seconds if they have version lower than 2.0
	Crew.WarnUserUMMUNotInstalled("CENTURI1");



	// THIS IS FOR ADDING CREW SEE PDF doc "Allow user to add crew to your ship 
	// without scenery editor"
	AddUMmuToVessel();
	
APbeaconpos[0].x = LP1_pos.x;
 APbeaconpos[0].y = LP1_pos.y;
 APbeaconpos[0].z = LP1_pos.z;
 
 APbeaconpos[1].x = LP2_pos.x;
 APbeaconpos[1].y = LP2_pos.y;
 APbeaconpos[1].z = LP2_pos.z;

APbeaconpos[2].x = LP3_pos.x;
 APbeaconpos[2].y = LP3_pos.y;
 APbeaconpos[2].z = LP3_pos.z;
 
 APbeaconpos[3].x = LP4_pos.x;
 APbeaconpos[3].y = LP4_pos.y;
 APbeaconpos[3].z = LP4_pos.z;

 APbeaconpos[4].x = LP5_pos.x;
 APbeaconpos[4].y = LP5_pos.y;
 APbeaconpos[4].z = LP5_pos.z;

 for (int i = 0; i < 4; i++) {
                APbeacon[i].active = false;

 APbeacon[4].active = true;

if (PADSel==1){
				APbeacon[0].active = true;}
			
			if (PADSel==2){
				APbeacon[1].active = true;}
			if (PADSel==3){
				APbeacon[2].active = true;}

			if (PADSel==4){
				APbeacon[3].active = true;}
			
 }

 {LP1_pos.z=LP1_INT_POS-(DOCK1_proc*14);}
 {LP2_pos.x=LP2_INT_POS-(DOCK2_proc*15);}

 {LP3_pos.z=LP3_INT_POS+(DOCK3_proc*14);}
 {LP4_pos.x=LP4_INT_POS+(DOCK4_proc*15);}



if (DOCK1_status >= RDOOR_RAISING) {
		double da = simdt * LIFT_SPEED;
		if (DOCK1_status == RDOOR_RAISING) {
			if (DOCK1_proc > 0.0) DOCK1_proc = max (0.0, DOCK1_proc-da);
			else                DOCK1_status = RDOOR_UP;
		} else {
			if (DOCK1_proc < 1.0) DOCK1_proc = min (1.0, DOCK1_proc+da);
			else                DOCK1_status = RDOOR_DOWN;
		}
SetAnimation (anim_DOCKARM1, DOCK1_proc);
}
if (DOCK2_status >= RDOOR_RAISING) {
		double da = simdt * LIFT_SPEED;
		if (DOCK2_status == RDOOR_RAISING) {
			if (DOCK2_proc > 0.0) DOCK2_proc = max (0.0, DOCK2_proc-da);
			else                DOCK2_status = RDOOR_UP;
		} else {
			if (DOCK2_proc < 1.0) DOCK2_proc = min (1.0, DOCK2_proc+da);
			else                DOCK2_status = RDOOR_DOWN;
		}
SetAnimation (anim_DOCKARM2A, DOCK2_proc);
SetAnimation (anim_DOCKARM2B, DOCK2_proc);
SetAnimation (anim_DOCKARM2C, DOCK2_proc);
}
if (DOCK3_status >= RDOOR_RAISING) {
		double da = simdt * LIFT_SPEED;
		if (DOCK3_status == RDOOR_RAISING) {
			if (DOCK3_proc > 0.0) DOCK3_proc = max (0.0, DOCK3_proc-da);
			else                DOCK3_status = RDOOR_UP;
		} else {
			if (DOCK3_proc < 1.0) DOCK3_proc = min (1.0, DOCK3_proc+da);
			else                DOCK3_status = RDOOR_DOWN;
		}
SetAnimation (anim_DOCKARM3, DOCK3_proc);
}
if (DOCK4_status >= RDOOR_RAISING) {
		double da = simdt * LIFT_SPEED;
		if (DOCK4_status == RDOOR_RAISING) {
			if (DOCK4_proc > 0.0) DOCK4_proc = max (0.0, DOCK4_proc-da);
			else                DOCK4_status = RDOOR_UP;
		} else {
			if (DOCK4_proc < 1.0) DOCK4_proc = min (1.0, DOCK4_proc+da);
			else                DOCK4_status = RDOOR_DOWN;
		}
SetAnimation (anim_DOCKARM4A, DOCK4_proc);
SetAnimation (anim_DOCKARM4B, DOCK4_proc);
SetAnimation (anim_DOCKARM4C, DOCK4_proc);
}


}








void CENTURI1::DefineAnimations(void)

{

   	static UINT EGrp20[1] = {116};//dock2a
   	static UINT EGrp21[1] = {115};//dock2b
	static UINT EGrp31[1] = {68};//dock2b
   	
   static MGROUP_TRANSLATE DOCK2a(0,EGrp20, 1, _V(-15.1,0,0));
   static MGROUP_TRANSLATE DOCK2b(0,EGrp21, 1, _V(-7,0,0));
      static MGROUP_TRANSLATE DOCK2c(0,EGrp31, 1, _V(-15.1,0,0));

anim_DOCKARM2A = CreateAnimation (0); 
AddAnimationComponent  (anim_DOCKARM2A, 0, 1, &DOCK2a) ;   
anim_DOCKARM2B = CreateAnimation (0); 
AddAnimationComponent  (anim_DOCKARM2B, 0, 1, &DOCK2b) ;  
anim_DOCKARM2C = CreateAnimation (0); 
AddAnimationComponent  (anim_DOCKARM2C, 0, 1, &DOCK2c) ;   
  

   	static UINT EGrp22[1] = {111};//dock4a
   	static UINT EGrp23[1] = {110};//dock4b
	 	static UINT EGrp33[1] = {67};//dock4b
   	
   static MGROUP_TRANSLATE DOCK4a (0,EGrp22, 1, _V(15.1,0,0));
   static MGROUP_TRANSLATE DOCK4b (0,EGrp23, 1, _V(7,0,0));
      static MGROUP_TRANSLATE DOCK4c (0,EGrp33, 1, _V(15.1,0,0));

anim_DOCKARM4A = CreateAnimation (0); 
AddAnimationComponent  (anim_DOCKARM4A, 0, 1, &DOCK4a) ;   
anim_DOCKARM4B = CreateAnimation (0); 
AddAnimationComponent  (anim_DOCKARM4B, 0, 1, &DOCK4b) ; 
anim_DOCKARM4C = CreateAnimation (0); 
AddAnimationComponent  (anim_DOCKARM4C, 0, 1, &DOCK4c) ;  

  
  	static UINT EGrp24[1] = {122};//dock3a
   	
   	
   static MGROUP_TRANSLATE DOCK3a (0,EGrp24, 1, _V(0,0,14));
   
anim_DOCKARM3 = CreateAnimation (0); 
AddAnimationComponent  (anim_DOCKARM3, 0, 1, &DOCK3a) ;   
  
  
  	static UINT EGrp25[1] = {113};//dock1a
   	
   	
   static MGROUP_TRANSLATE DOCK1a (0,EGrp25, 1, _V(0,0,-14));
   
anim_DOCKARM1 = CreateAnimation (0); 
AddAnimationComponent  (anim_DOCKARM1, 0, 1, &DOCK1a) ;   

 	
   }

DLLCLBK VESSEL *ovcInit (OBJHANDLE hvessel, int flightmodel)
{
return new CENTURI1 (hvessel, flightmodel);
}

DLLCLBK void ovcExit (VESSEL *vessel)
{
if (vessel) delete (CENTURI1*)vessel;
}

// --------------------------------------------------------------
// Keyboard interface handler (buffered key events)
// --------------------------------------------------------------
int CENTURI1::clbkConsumeBufferedKey(DWORD key, bool down, char *kstate)

{
	// only process keydown events
	if (!down) 
		return 0; 

//---------------------------------------------------------------------------
	// Ummu Key "E" perform the EVA of the selected member
	//
	// ADD REALISM: It's your responsabilities also to set ship's control accordingly to crew aboard.
	//				If you want to disable control if no one is aboard have a look at "SetADCtrlMode()"
	//				and "SetAttitudeMode()" functions of Orbiter. To disable thrusters set their fuel 
	//				ressource to NULL.
	if(key==OAPI_KEY_E&&!KEYMOD_SHIFT(kstate)&&!KEYMOD_CONTROL (kstate))
	{
		// PERFORM THE EVA, first we get is name with "GetCrewNameBySlotNumber" then we perform EVA with "EvaCrewMember"
		int Returned=Crew.EvaCrewMember(Crew.GetCrewNameBySlotNumber(SelectedUmmuMember));
		// we provide feedback to user (You can display a message on panel or wathewer)
		// here below all the return code possible:
		switch(Returned)
		{
		case TRANSFER_TO_DOCKED_SHIP_OK:
			sprintf(SendHudMessage(),"Transfer to docked ship Ok - %s transfered",
			Crew.GetLastEvaedCrewName());SelectedUmmuMember=0;
			break;
		case EVA_OK:
			sprintf(SendHudMessage(),"EVA OK - %s left the ship",
			Crew.GetLastEvaedCrewName());SelectedUmmuMember=0;
			break;
		case ERROR_NO_ONE_ON_BOARD:
			strcpy(SendHudMessage(),"Error, no one on board, unable to EVA");
			break;
		case ERROR_AIRLOCK_CLOSED:
			strcpy(SendHudMessage(),"Error, airlock is closed, unable to EVA");
			break;
		case ERROR_DOCKED_SHIP_HAVE_AIRLOCK_CLOSED:
			strcpy(SendHudMessage(),"Error, docked ship's airlock is closed, unable to transfer");
			break;
		case ERROR_DOCKED_SHIP_IS_FULL:
			strcpy(SendHudMessage(),"Error, docked ship is already full transfer failed");
			break;
		case ERROR_CREW_MEMBER_NOT_FOUND:
			strcpy(SendHudMessage(),"Error, no crew by this name in ship");
			break;
		case ERROR_DOCKEDSHIP_DONOT_USE_UMMU:
			strcpy(SendHudMessage(),"Error, docked ship do not use UMmu 2.0, ask author to add it");
			break;
		case ERROR_MISC_ERROR_EVAFAILED:
			strcpy(SendHudMessage(),"Misc error with UMMU install it again");
			break;
		}
		return TRUE;
	}

	//---------------------------------------------------------------------------
	// Ummu Key "1" Select next member This is just internal to the demo
	// you may do your own selection system by panel button, name etc etc
	if(key==OAPI_KEY_1&&!KEYMOD_SHIFT(kstate)&&!KEYMOD_CONTROL (kstate))
	{
		// we test there is someone aboard
		if(Crew.GetCrewTotalNumber()==0)
		{
			strcpy(SendHudMessage(),"Sorry no one aboard unable to select");	
			return 1;
		}

		// we test that we select existing member
		if(SelectedUmmuMember<Crew.GetCrewTotalNumber()-1)
			SelectedUmmuMember++;
		char * Name=Crew.GetCrewNameBySlotNumber(SelectedUmmuMember);
		sprintf(SendHudMessage(),"Slot %i  %s \"%s\" aged %i Selected for EVA or Transfer, please press \"E\" to EVA",
		SelectedUmmuMember,Crew.GetCrewMiscIdBySlotNumber(SelectedUmmuMember),
		Name,Crew.GetCrewAgeBySlotNumber(SelectedUmmuMember));
		return 1;
	}

	//---------------------------------------------------------------------------
	// Ummu Key "2" Select previous member This is just internal to the demo
	// you may do your own selection system by panel button
	if(key==OAPI_KEY_2&&!KEYMOD_SHIFT(kstate)&&!KEYMOD_CONTROL (kstate))
	{
		// we test there is someone aboard
		if(Crew.GetCrewTotalNumber()==0)
		{
			strcpy(SendHudMessage(),"Sorry no one aboard unable to select");	
			return 1;
		}
		if(SelectedUmmuMember>0)
			SelectedUmmuMember--;
		char * Name=Crew.GetCrewNameBySlotNumber(SelectedUmmuMember);
		sprintf(SendHudMessage(),"Slot %i %s \"%s\" aged %i Selected for EVA or Transfer"
			", please press \"E\" to EVA",SelectedUmmuMember,
			Crew.GetCrewMiscIdBySlotNumber(SelectedUmmuMember),Name,
			Crew.GetCrewAgeBySlotNumber(SelectedUmmuMember));
		return 1;
	}
	//---------------------------------------------------------------------------
	// Ummu Key "A" Switch the virtual UMMU airlock door on/off
	if(key==OAPI_KEY_D&&!KEYMOD_SHIFT(kstate)&&!KEYMOD_CONTROL (kstate))
	{		
	//
		Crew.SetAirlockDoorState(!Crew.GetAirlockDoorState());
		// display state

{
		

		
		if(Crew.GetAirlockDoorState()==TRUE)
			strcpy(SendHudMessage(),"Airlock is now open");	
		else
			strcpy(SendHudMessage(),"Airlock is now closed");
		}

	

	}

	//---------------------------------------------------------------------------
	// Get some infos Name of ship and total soul aboard
	if(key==OAPI_KEY_S)
	{
		sprintf(SendHudMessage(),"%i souls aboard ship %s, %i seats available",
			Crew.GetCrewTotalNumber(),GetName(),99-Crew.GetCrewTotalNumber());
		return 1;
	}

	//---------------------------------------------------------------------------
	// ADD some Fun, Eject the guy, No check of all return code here to keep listing small and clear.
	// Notice eject function doesn't check airlock state at all.
	// GOOD IDEA: Get the Object's handle after ejection with function "GetObjHandleOfLastEVACrew"
	// and add to it one very small tank, thruster and smoke, then fire thruster (see pilot ejection of DGIV)
	// BAD IDEA: Not testing the handle returned by "GetObjHandleOfLastEVACrew" before using may
	// cause a CTD if by any bad luck the pointer is invalid (handle==NULL)
	if(key==OAPI_KEY_ESCAPE&&!KEYMOD_SHIFT(kstate)&&!KEYMOD_CONTROL (kstate))
	{
		if(Crew.EjectCrewMember(Crew.GetCrewNameBySlotNumber(SelectedUmmuMember))==EVA_OK)
			sprintf(SendHudMessage(),"%s EJECTED",Crew.GetLastEvaedCrewName());
		SelectedUmmuMember=0;
		return 1;
	}

	//---------------------------------------------------------------------------
	// Use a different Mesh (type "C" then EVA someone)
	// better idea is to use the new UMMU Id definition
	// look readme.txt in folder "config/UMMUIdConfig"
	if(key==OAPI_KEY_C)
	{
		Crew.SetAlternateMeshToUseForEVASpacesuit("mmu");	// the stock mmu of orbiter located in "meshes/mmu.msh"
		strcpy(SendHudMessage(),"Mesh changed");
		return 1;
	}

	// THIS IS FOR ADDING CREW SEE PDF doc "Allow user to add crew to your ship 
	// without scenery editor"
	if(key==OAPI_KEY_M&&!KEYMOD_SHIFT(kstate)&&!KEYMOD_CONTROL (kstate))
	{
		AddUMmuToVessel(TRUE);
	}
 

            
/*/if(key==OAPI_KEY_3) // rotate+
{
     RevertDOCK1();
			return 1;
}    
if(key==OAPI_KEY_4) // rotate-
{
      RevertDOCK2();
			return 1;
}
		
if(key==OAPI_KEY_5) // rotate+
{
    RevertDOCK3();
			return 1;
}   
if(key==OAPI_KEY_6) // rotate-
{
     RevertDOCK4();
			return 1;
}
*/		
if(key==OAPI_KEY_K) // rotate-
{
	do_attach = 1;
     Attachships();
			return 1;
}
if(key==OAPI_KEY_J) // rotate-
{
     Detachships();
			return 1;
}
if(key==OAPI_KEY_V)
{
             {SelectCockpitView(CAM);
	            
	            CAM = CAM + 1;
            if(CAM > 4) CAM = 0;
        }
            return 1;
}
if(key==OAPI_KEY_W)// SELECT
            {
				PADSel = PADSel + 1;
             if(PADSel > 4) PADSel = 1;
			 return 1;
}
if(key==OAPI_KEY_O)//cargobayif (RAIL1_proc==0){
{
	if (PADSel==1){
		RevertDOCK1 ();}
	if (PADSel==2){
		RevertDOCK2 ();}
	if (PADSel==3){ 
		RevertDOCK3 ();}
	if (PADSel==4){
		RevertDOCK4 ();}
	return 1;		
}

return 0;
}
// ====================================================================
// clbkVisualCreated used to display UMMU initialisation message 
// because oapiDebugString() doesn't work in clbkSetClassCap
// ====================================================================
void CENTURI1::clbkVisualCreated (VISHANDLE vis, int refcount)
{   
	MainExternalMeshVisual = GetMesh(vis,0);
}
// ==============================================================
// Visual destroyed
// ==============================================================
void CENTURI1::clbkVisualDestroyed (VISHANDLE vis, int refcount)
{
	MainExternalMeshVisual = 0;	
}

	
void CENTURI1::clbkDrawHUD(int iMode, const HUDPAINTSPEC* pHPS, HDC hdc)
{

	VESSEL2::clbkDrawHUD(iMode, pHPS, hdc);
	HUD_Text(pHPS, hdc);

{
		TextOut (hdc,5,pHPS->H/60*15,cUmmuHudDisplay,strlen(cUmmuHudDisplay));
		dHudMessageDelay-=oapiGetSimStep();
		if(dHudMessageDelay<0)
			dHudMessageDelay=0;
	}


}

void CENTURI1::clbkSaveState(FILEHANDLE scn)
{
char cbuf[256];
	
	// ORBITER, default vessel parameters
	SaveDefaultState (scn);
sprintf (cbuf, "%d %0.4f", DOCK1_status, DOCK1_proc);
		oapiWriteScenario_string (scn, "DOCK1", cbuf);

		sprintf (cbuf, "%d %0.4f", DOCK2_status, DOCK2_proc);
		oapiWriteScenario_string (scn, "DOCK2", cbuf);

		sprintf (cbuf, "%d %0.4f", DOCK3_status, DOCK3_proc);
		oapiWriteScenario_string (scn, "DOCK3", cbuf);

		sprintf (cbuf, "%d %0.4f", DOCK4_status, DOCK4_proc);
		oapiWriteScenario_string (scn, "DOCK4", cbuf);


	// UMmu, this will save all our members of crew in scenario
	// as airlock state depend of your ship (you may have a real animated airlock)
	// it's your responsabilites to save and reload UMmu's airlock state.
	Crew.SaveAllMembersInOrbiterScenarios(scn);
}
void CENTURI1::clbkLoadStateEx (FILEHANDLE scn, void *status)
{
	char *line;
	while (oapiReadScenario_nextline (scn, line)) 
	{
		// UMMU, Load all saved member from scenario. 
		// Return TRUE when a "UMMUCREW" line is encountered 
		// FALSE when it must pass this line to you or default parser
		if(Crew.LoadAllMembersFromOrbiterScenario(line)==TRUE)
			continue;
	      if (!_strnicmp (line, "DOCK1", 5)) {
   sscanf (line+5, "%d%lf", &DOCK1_status, &DOCK1_proc);
			}
		        if (!_strnicmp (line, "DOCK2", 5)) {
   sscanf (line+5, "%d%lf", &DOCK2_status, &DOCK2_proc);
			}
				      if (!_strnicmp (line, "DOCK3", 5)) {
   sscanf (line+5, "%d%lf", &DOCK3_status, &DOCK3_proc);
			}
					        if (!_strnicmp (line, "DOCK4", 5)) {
   sscanf (line+5, "%d%lf", &DOCK4_status, &DOCK4_proc);
			}
		// ORBITER, unrecognised option - pass to Orbiter's generic parser
		ParseScenarioLineEx (line, status);
	}
	SetAnimation (anim_DOCKARM1, DOCK1_proc);

SetAnimation (anim_DOCKARM2A, DOCK2_proc);
SetAnimation (anim_DOCKARM2B, DOCK2_proc);
SetAnimation (anim_DOCKARM2C, DOCK2_proc);
SetAnimation (anim_DOCKARM3, DOCK3_proc);

SetAnimation (anim_DOCKARM4A, DOCK4_proc);
SetAnimation (anim_DOCKARM4B, DOCK4_proc);
SetAnimation (anim_DOCKARM4C, DOCK4_proc);
	// as airlock state depend of your ship (you may have a real animated airlock)
	// it's your responsabilites to save and reload UMmu airlock state and set it accordingly
	// to your airlock. IE: call here "SetAirlockDoorState" TRUE of FALSE depend
	// of your animated airlock
}
bool UMmuCrewAddCallback(void *id, char *str, void *data)
{
	if(strlen(str)<2||strlen(str)>38)
		return false;
	char *cPtr=(char*)data;	if(*cPtr==2){*cPtr=3;strcpy(cPtr+2,str);}
	else if(*cPtr==4){*cPtr=5;strcpy(cPtr+42,str);}
	else if(*cPtr==6){*cPtr=7;strcpy(cPtr+82,str);}return true;
}
void CENTURI1::AddUMmuToVessel(BOOL bStartAdding)
{
	if(bStartAdding==FALSE&&cAddUMmuToVessel[0]==0)
		return;
	if(bStartAdding==TRUE){
		int salut=sizeof(cAddUMmuToVessel);
		memset(cAddUMmuToVessel,0,sizeof(cAddUMmuToVessel));
		cAddUMmuToVessel[0]=1;
	}
	else if(cAddUMmuToVessel[0]==1){
		cAddUMmuToVessel[0]=2;
		oapiOpenInputBox ("Enter new crew's name (or escape)",UMmuCrewAddCallback,0,30,(void*)cAddUMmuToVessel);
	}
	else if(cAddUMmuToVessel[0]==3){
		cAddUMmuToVessel[0]=4;
		oapiOpenInputBox ("Enter crew's age",UMmuCrewAddCallback,0,30,(void*)cAddUMmuToVessel);
	}
	else if(cAddUMmuToVessel[0]==5){
		cAddUMmuToVessel[0]=6;
		oapiOpenInputBox ("Enter function (Capt,Sec,Vip,Sci,Doc,Tech,Crew,Pax)",UMmuCrewAddCallback,0,30,(void*)cAddUMmuToVessel);
	}
	else if(cAddUMmuToVessel[0]==7){
		cAddUMmuToVessel[0]=0;
		int Age=max(5,min(100,atoi(&cAddUMmuToVessel[42])));
		if(Crew.AddCrewMember(&cAddUMmuToVessel[2],Age,70,70,&cAddUMmuToVessel[82])==TRUE){
			sprintf(SendHudMessage(),"Crew \"%s\" aged %i added to vessel",&cAddUMmuToVessel[2],Age);
		}
		else{
			strcpy(SendHudMessage(),"ERROR: Crew not added (vessel full?)");
		}
	}
}
// END of  "Allow user to add crew to your ship without scenery editor"
//-------------------------------------------------------------------------





void CENTURI1::RevertDOCK1 (void)
{
	DOCK1_status = ((DOCK1_status == RDOOR_UP || DOCK1_status == RDOOR_RAISING) ?
		RDOOR_LOWERING : RDOOR_RAISING);
}
void CENTURI1::RevertDOCK2 (void)
{
	DOCK2_status = ((DOCK2_status == RDOOR_UP || DOCK2_status == RDOOR_RAISING) ?
		RDOOR_LOWERING : RDOOR_RAISING);
}
void CENTURI1::RevertDOCK3 (void)
{
	DOCK3_status = ((DOCK3_status == RDOOR_UP || DOCK3_status == RDOOR_RAISING) ?
		RDOOR_LOWERING : RDOOR_RAISING);
}
void CENTURI1::RevertDOCK4 (void)
{
	DOCK4_status = ((DOCK4_status == RDOOR_UP || DOCK4_status == RDOOR_RAISING) ?
		RDOOR_LOWERING : RDOOR_RAISING);
}
void CENTURI1::Attachships(){
             VECTOR3 aphpos, aphdir, aphrot, gaph;
             VECTOR3 shippos, shipdir, shiprot, gpship;

             // get attachment point positions based on selected point
             switch (int(APSel)) {
                
                case 0:
                    GetAttachmentParams(D5,aphpos, aphdir, aphrot);
                    break;
                

             }

             // change the position to a global one rather then a local one. This will allow me to offset it from the local center.
             // the local position is stored in gaph
             Local2Global (aphpos, gaph);

             //I now know were the attach point is in the global world
             //Now lets find out if there is a skid in range
             // Search the complete vessel list for a grappling candidate.
            // Not very scalable ...
                for (DWORD i = 0; i < oapiGetVesselCount(); i++) {
                    OBJHANDLE hV = oapiGetVesselByIndex (i);    //get handle for ship
        //            if (strncmp (hV->GetClassName(), "QJFFS", 5)!=0  ){  //restrict to only QuadJ ships to make it easy.

                    // Look for any ship with a child attach point. This allows the Mule to grap any object
                    if (hV == GetHandle()) continue; // If self then continue onward because we don't want to grapple ourselves ...

                    oapiGetGlobalPos (hV, &gpship); // get global postion of ship and put into gpship

                    if (dist(gpship, gaph) < oapiGetSize (hV)) { // Make sure that the ship is close enough to the mule
                       // looks close enough so lets look for that attach point

                       VESSEL *v = oapiGetVesselInterface (hV);
                       // Only look for child attach point
                       DWORD nAttach = v->AttachmentCount (true); //Get attachment count. I do this so that I can grap any child point.
                       if (nAttach > 0){ // Only continue if ship has a child attach point
                           for (DWORD j = 0; j < nAttach; j++) { // now scan all attachment points of the candidate and check how far away from the attach point it is
                               ATTACHMENTHANDLE hAtt = v->GetAttachmentHandle (true, j);
                               // this would allow me to filter out all but QJ ships but I don't want to right now
                               const char *id = v->GetAttachmentId (hAtt);
                               if (strncmp (id, "APR", 2)) continue; // attachment point not compatible
                               
                               v->GetAttachmentParams (hAtt, shippos, shipdir, shiprot); //lets get the attach point position
                               v->Local2Global (shippos, gpship); // and change it to a global position Recycle of gpship cause I can
                               if (dist (gpship, gaph) < MAX_GRAP_DIST) { // Is it close enough to grab?
                                   apd = dist(gpship, gaph);
                                   // Yes! Then lets grab the little bugger and get out of here
                                   // Yes! Then lets grab the little bugger and get out of here
                                   if(do_attach > 0){
                                     do_attach = 0;
                                   switch (int(APSel)) {
                                         
                                         case 0:
                                               AttachChild (hV, D5, hAtt);
                                               break;
                                        
                                         
                                   }
                                   }
                                  return;
                               }
                            } // End of for j
                       }
                    }
                }  // end of for i
                return;
}
void CENTURI1::Detachships ()
{
    switch (int(APSel)) {
        
        case 0:
             DetachChild(D5,2.0);
             break;
        
       
        
        }
}
void CENTURI1::HUD_Text(const HUDPAINTSPEC* pHPS, HDC hdc)	
	
{	
	char cbuf[128];
//  char cbuf2[128];
  int n, tx, ty, ty2, yoff, n1,n3,ty3,ty4,ty5;
  GetTextMetrics(hdc, &tm);
  yoff = tm.tmHeight;
  tx = tm.tmAveCharWidth;
  ty4 = 15 * yoff;
  ty3 = 13 * yoff;
  ty = 15 * yoff;
  ty2 = 16 * yoff;
ty5 = 12 *yoff;
  //Rectangle (hdc, tx-2, ty-1, tx+120,ty+(yoff*7));
  SetTextColor (hdc, colRed);
n3 = sprintf (cbuf, "DOCK: %d", (PADSel));
  TextOut(hdc,tx,ty5,cbuf,n3 );

  n1 = sprintf (cbuf, "CAMERA: ");
  TextOut(hdc,tx,ty3,cbuf,n1 );
 // n1 = sprintf (cbuf, "CAMERA: " );
  //TextOut(hdc,tx,ty3,cbuf,n1 );
          SelectCockpitView(CAM);

   
  if (CAM==0){n=sprintf (cbuf, "PAD ");
  TextOut(hdc,tx+75,ty3,cbuf,n );}
  if (CAM==1){n=sprintf (cbuf, "DOCK 1 ");
  TextOut(hdc,tx+75,ty3,cbuf,n );}
  if (CAM==2){n=sprintf (cbuf, "DOCK 2 ");
  TextOut(hdc,tx+75,ty3,cbuf,n );}
  if (CAM==3){n=sprintf (cbuf, "DOCK 3 ");
  TextOut(hdc,tx+75,ty3,cbuf,n );}
  if (CAM==4){n=sprintf (cbuf, "DOCK 4 ");
  TextOut(hdc,tx+75,ty3,cbuf,n );}
SetTextColor (hdc, colGreen);
}